# [A](https://codeforces.com/gym/104857/problem/D)

称一个长度为 $l$ 的数列 $a$ 为平衡的，当且仅当其满足下列条件

- 存在一个整数 $k$，满足 $1\le k\le \frac {l-1}2$

- 对于每个 $i=1,2,...,l-2k$，有 $a_i+a_{i+2k}=2a_{i+k}$

现在给定一个长度为 $n$ 的数列 $a$，请对于每个 $i\in[1,n]$，判断长度为 $i$ 的前缀 $a_1,a_2,...,a_i$ 组成的数列是否为平衡的。

数据范围：$n\le 2\times 10^6,1\le a_i\le 2\times 10^8$

# [B](https://codeforces.com/gym/104768/problem/I)

给定一个长度为 $n$ 的数列 $a$，请找到一个连续区间 $a_l,a_{l+1},...,a_r$ 使得其中不同的数字个数减去其中数字的mex最大，输出这个最大值。

- 一个数列的mex是其中没有出现过的最小正整数。

数据范围：多组数据，$\sum n\le 5\times 10^5,1\le a_i\le 5\times10^5$

# [C](https://codeforces.com/gym/104901/problem/K)

对于一个长度为 $n$ 的数列 $a$，我们认为连续子序列 $a_l,...,a_r$ 是一个"彩虹子序列"当且仅当对于所有 $l\le i<r$，有 $a_{i+1}-a_i=1$。

你可以进行 $k$ 次操作，每次可以将数列里的某个元素增加或减少 $1$。请最大化在进行至多 $k$ 次操作后数列里最长的彩虹子序列的长度，并输出这个长度。

数据范围：多组数据，$\sum n\le 5\times 10^5,0\le k\le 10^{15},1\le a_i\le 10^9$

# [D](https://codeforces.com/gym/103055/problem/B)

给定 $n$ 个平面直角坐标系上的矩形，每一个矩形左上角坐标为 $(xa_i,ya_i)$，右下角坐标为 $(xb_i,yb_i)$，矩形之间可能有重合部分。

有 $q$ 个询问，每个询问给定 $s_i,t_i$，你需要求出在忽略第 $s_i$ 到第 $t_i$ 个输入的矩形时剩余的矩形覆盖的总面积，矩形之间的重合部分在计算总面积时只考虑一次。

数据范围：$1\le n,q\le 10^5,0\le xa_i,xb_i,ya_i,yb_i\le 2000$

# [E](https://codeforces.com/gym/104821/problem/M)

给定一个长为 $n$ 的序列 $a_1,a_2,...,a_n$，共 $q$ 次操作，第 $i$ 次操作会将 $a_{x_i}$ 的值增加 $v_i$，设 $f_i$ 表示前缀最大值，$g_i$ 表示后缀最大值，每次操作后求 $$\sum_{i=1}^n(\min(f_i,g_i)-a_i)$$

数据范围：多组数据，$1\le n,q\le 10^5,1\le a_i,v_i\le 10^6,1\le \sum n,\sum q\le 10^6$